;***************************************************************************
;
; File Name		:'Phone.asm"
; Title			:AVR PAC GSM Voice Phone Dialer
; Date			:2003.08.17.
; Version		:1.0.0
; Support telephone	:+36-70-333-4034,  old: +36-30-9541-658 VFX
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:AVR
;
;***************************************************************************
;	D E S C R I P T I O N
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  	why
;	----	----------  ---		------------------------------------
;	0.01	2003.08.17  VFX		Creation
;
;***************************************************************************
;Hardware
;***************************************************************************
;*
;*	SYSCLK: f=16.000 MHz (T= 62.5 ns)
;*
;***************************************************************************
;
;
;**************************************************************************
;* Hardware Def.
;
;***************************************************************************
;**** VARIABLES
.DSEG

;***************************************************************************
.ESEG


;***************************************************************************
;**** CODE SEG
;***************************************************************************
.CSEG

.include "PACPhone.asm"



PutPhone:
		ldi	ZL,Low(PACPhone*2)
		ldi	ZH,high(PACPhone*2)
		ldi	R16,(PACPhone)/32768
		out	RAMPZ,R16


		ldi	R20,SRAMBASE		;SRAM RAM Base Address for DMA
		sts	ADR_EXLH,R20		;Lower memory Banks
		inc	R20
		sts	ADR_EXHL,R20		;Continous 48kb VideoMemory
		inc	R20
		sts	ADR_EXHH,R20
		clr	R2

		ldi	R19,S1D_DISPLAY_SCANLINE_BYTES


		ldd	XH,Z+BMPHeight
		ldd	YL,Z+BMPWidth
		lsr	YL			;2 pixel/byte
		mov	R3,YL
		mul	XH,R19
		ldi	R16,84
		add	R0,R16
		adc	R1,R2
		ldi	YL,Low(MMAP1)
		ldi	YH,High(MMAP1)
		add	YL,R0
		adc	YH,R1
		
		ldd	R16,Z+BMPDataOffset
		add	ZL,R16
		adc	ZH,R2



		ldi	R18,74
		mov	R3,R18
		ldi	XH,240
		ldi	YL,Low(MMAP1+38326)
		ldi	YH,High(MMAP1+38326)

		ldi	ZL,Low(PACPhone*2+BMPColorTable+4*16)
		ldi	ZH,high(PACPhone*2+BMPColorTable+4*16)



FillVideox1:
		push	YL
		push	YH
		mov	R18,R3
                        
FV2:
		elpm	R0,Z+
		st	Y+,R0
		dec	R18
		brne	FV2
		ld	R0,Z+
		ld	R0,Z+		;dumy read ???!!!!???!!!

		pop	YH
		pop	YL
		sub	YL,R19
		sbc	YH,R2
		dec	XH
		brne	FillVideox1
		ret

