;***************************************************************************
;
; File Name		:'sed1375.asm"
; Title			:DataLog S1D13705 LCD Controller
; Date			:2003.06.14.
; Version		:1.0.0
; Support telephone	:+36-70-333-4034 VFX
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:ATmega128
;
;***************************************************************************
;	D E S C R I P T I O N
;
;Chip Header information generated by 13705CFG.EXE (Build 9)
;
;
;
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  	why
;	----	----------  ---		--------------------------------------------
;	0.01	2003.06.14  VFX		Creation
;
;
;***************************************************************************
;Hardware
;***************************************************************************
;*
;*	Oscillator: f=external, 16.0000 MHz (T=62.5ns)
;*
;*	SED CLKI = 12.288MHz
;***************************************************************************
;
;
;
;***************************************************************************
;* Const Def
;
;  Establishes name/value pairs for all the registers,
;  which can be used by software, such as display drivers.
;
.equ  RevisionCode	= 0x0000    ;Revision Code Register
.equ  ModeRegister0	= 0x0001    ;Mode Register 0 Register
.equ  ModeRegister1	= 0x0002    ;Mode Register 1 Register
.equ  ModeRegister2	= 0x0003    ;Mode Register 2 Register
.equ  HorzPanelSize	= 0x0004    ;Horizontal Panel Size Register
.equ  VertPanelSizeLSB	= 0x0005    ;Vertical Panel Size Register (LSB)
.equ  VertPanelSizeMSB	= 0x0006    ;Vertical Panel Size Register (MSB)
.equ  FPLineStartPos	= 0x0007    ;FPLINE Start Position Register
.equ  HorzNondispPeriod	= 0x0008    ;Horizontal Non-Display Period Register
.equ  FPFrameStartPos	= 0x0009    ;FPFRAME Start Position Register
.equ  VertNondispPeriod	= 0x000A    ;Vertical Non-Display Period Register
.equ  MODRate		= 0x000B    ;MOD Rate Register
.equ  Scrn1StartAddrLSB	= 0x000C    ;Screen 1 Start Address Register (LSB)
.equ  Scrn1StartAddrMSB	= 0x000D    ;Screen 1 Start Address Register (MSB)
.equ  Scrn2StartAddrLSB	= 0x000E    ;Screen 2 Start Address Register (LSB)
.equ  Scrn2StartAddrMSB	= 0x000F    ;Screen 2 Start Address Register (MSB)
.equ  ScrnStartAddr	= 0x0010    ;Screen Start Address Overflow Register
.equ  MemAddrOffset	= 0x0011    ;Memory Address Offset Register
.equ  Scrn1VertSizeLSB	= 0x0012    ;Screen 1 Vertical Size Register (LSB)
.equ  Scrn1VertSizeMSB	= 0x0013    ;Screen 1 Vertical Size Register (MSB)
.equ  NotPresent1	= 0x0014    ;Not Used
.equ  LutAddr		= 0x0015    ;Look-Up Table Address Register
.equ  NotPresent2	= 0x0016    ;Not Used
.equ  LutData		= 0x0017    ;Look-Up Table Data Register
.equ  GPIOConfig	= 0x0018    ;GPIO Configuration Control Register
.equ  GPIOStatus	= 0x0019    ;GPIO Status/Control Register
.equ  Scratchpad	= 0x001A    ;Scratch Pad Register
.equ  PortraitMode	= 0x001B    ;SwivelView Mode Register
.equ  LineByteCount	= 0x001C    ;Line Byte Count Register
.equ  NotPresent3	= 0x001D    ;Not Used
.equ  Framing		= 0x001E    ;Not Used
.equ  TestMode		= 0x001F    ;Not Used

;**************************************************************************
;* Hardware Def.
;
;  Panel: Hitachi SP14Q002-C1A
;	  320x240x2bpp 72Hz Mono 4-Bit STN (PCLK=12.288MHz)
;
;  This section defines the configuration environment and registers,
;  which can be used by any software, such as display drivers.
;

.equ S1D_DISPLAY_WIDTH               = 320
.equ S1D_DISPLAY_HEIGHT              = 240
.equ S1D_DISPLAY_BPP                 = 4
.equ S1D_DISPLAY_SCANLINE_BYTES      = 160
.equ S1D_DISPLAY_FRAME_RATE          = 72
.equ S1D_DISPLAY_PCLK                = 12288000
.equ S1D_PHYSICAL_REG_ADDR           = 0x0001FFE0
.equ S1D_PHYSICAL_VMEM_ADDR          = 0x00000000
.equ S1D_PHYSICAL_REG_SIZE           = 31
.equ S1D_PHYSICAL_VMEM_SIZE          = 81920
.equ S1D_PALETTE_SIZE                = 256
.equ S1D_FRAME_RATE                  = 72
.equ S1D_POWER_DELAY_OFF             = 500
.equ S1D_POWER_DELAY_ON              = 200
.equ S1D_REGDELAYOFF                 = 0xFE
.equ S1D_REGDELAYON                  = 0xFF




;***************************************************************************
;**** VARIABLES
.DSEG

VTR:	.byte	256		;256 byte test RAM kesobb nem kell
LCDFlag:.byte	1		;LCD Status/Flag
				;0. = 1 Back Light is On


;***************************************************************************
.ESEG


;***************************************************************************
;****		I N T E R R U P T S
;****
;***************************************************************************
.CSEG

.include "ch7x12.asm"
.include "ch8x12.asm"


S1D_Init:
		ldi	R16,low(LCDBackLightTime)
		sts	SCNT4+0,R16
		ldi	R16,high(LCDBackLightTime)
		sts	SCNT4+1,R16		;LCD Back Light Timer

		ldi	R16,1
		sts	LCDFlag,R16		;LCD ack Light On


		rcall	W200ms			;Wait min. 200ms

		ldi	ZL,Low(S1D_REGS*2);
		ldi	ZH,high(S1D_REGS*2);
		ldi	R16,(S1D_REGS/32768)	;Low/High part of FLASH
		out	RAMPZ,R16
		ldi	R16,VIDEOBASE+7
		sts	ADR_EXHH,R16		;Page to SED Registers

		clr	R10


S1D_Init1:	ldi	XL,low(0xFFE0)		;SED Register Base
		ldi	XH,High(0xFFE0)
		elpm	R17,Z+			;offset
		cpi	R17,0xFF
		breq	SedInit12

		add	XL,R17
		adc	XH,R10
		elpm	R1,Z+
		st	X,R1			;value
		nop
		nop
		nop
		nop
		nop
		nop
		rjmp	S1D_Init1
SedInit12:


		ldi	R16,4			;16 szurkearnyalat kell
		rcall	WriteLUT

		rcall	W200ms			;Wait min. 200ms to turn On Disp.

		ldi	XL,low(0xFFE0+ModeRegister2)	;SED Register
		ldi	XH,High(0xFFE0+ModeRegister2)
		ldi	R16,3
		st	X,R16			;LCD On
		nop
		nop
		nop
		nop
		nop
		nop


		rcall	W200ms

		ret


W200ms:
		ldi	R16,Low(SYSTACK/5)
		sts	SCNT1+0,R16
		ldi	R16,High(SYSTACK/5)
		sts	SCNT1+1,R16		;wait 0.2s = 1/5s
W201:		sleep
		nop
		lds	R16,SCNT1+0
		lds	R17,SCNT1+1
		or	R16,R17
		brne	W201
		ret


WriteLUT:
		cpi	R16,4
		breq	g16LUT

		ldi	ZL,Low(g_LUT2Bpp*2)		;Look-up Table
		ldi	ZH,High(g_LUT2Bpp*2)
		ldi	R16,(g_LUT2Bpp/32768)  		;Low/High part of FLASH
		out	RAMPZ,R16
		ldi	R17,4				;Count of Palette data
		rjmp	WriteLUT1
g16LUT:
		ldi	ZL,Low(g_LUT4Bpp*2)		;Look-up Table
		ldi	ZH,High(g_LUT4Bpp*2)
		ldi	R16,(g_LUT4Bpp/32768)		;Low/High part of FLASH
		out	RAMPZ,R16
		ldi	R17,16				;Count of Palette data

WriteLUT1:
		ldi	R20,VIDEOBASE+7		;SED RAM Regsiters
		sts	ADR_EXHH,R20

		ldi	XL,low(0xFFE0+LutAddr)		;SED LutAddr Register
		ldi	XH,High(0xFFE0+LutAddr)
		ldi	R16,0
		st	X,R16
		nop
		nop
		nop
		nop
		nop
		nop
		ldi	XL,low(0xFFE0+LutData)
		ldi	XH,High(0xFFE0+LutData)
WrLUT1:		elpm	R1,Z+
		nop
		nop
		nop
		st	X,R1
		nop
		nop
		nop
		nop
		nop
		elpm	R1,Z+
		st	X,R1
		nop
		nop
		nop
		nop
		nop
		elpm	R1,Z+
		st	X,R1
		nop
		nop
		nop
		nop
		nop
		elpm	R1,Z+
		dec	R17
		brne	WrLUT1
		ret



S1D_REGS:
;     .db 0x00, 0x24	  ;Revision Code Register (Read-Only)
     .db 0x01, 0x1C	  ;Mode Register 0 Register
     .db 0x02, 0xB0	  ;Mode Register 1 Register 0x70 for 2bpp, 0xB0 4bpp
     .db 0x03, 0x00	  ;Mode Register 2 Register
     .db 0x04, 0x27	  ;Horizontal Panel Size Register
     .db 0x05, 0xEF	  ;Vertical Panel Size Register (LSB)
     .db 0x06, 0x00	  ;Vertical Panel Size Register (MSB)
     .db 0x07, 0x05	  ;FPLINE Start Position Register
     .db 0x08, 0x00	  ;Horizontal Non-Display Period Register
     .db 0x09, 0x04	  ;FPFRAME Start Position Register
     .db 0x0A, 0x00	  ;Vertical Non-Display Period Register
     .db 0x0B, 0x00	  ;MOD Rate Register
     .db 0x0C, 0x00	  ;Screen 1 Start Address Register (LSB)
     .db 0x0D, 0x00	  ;Screen 1 Start Address Register (MSB)
     .db 0x0E, 0x00	  ;Screen 2 Start Address Register (LSB)
     .db 0x0F, 0x00	  ;Screen 2 Start Address Register (MSB)
     .db 0x10, 0x00	  ;Screen Start Address Overflow Register
     .db 0x11, 0x00	  ;Memory Address Offset Register
     .db 0x12, 0xFF	  ;Screen 1 Vertical Size Register (LSB)
     .db 0x13, 0x03	  ;Screen 1 Vertical Size Register (MSB)
;     .db 0x14, 0x00	  ;Not Used
;     .db 0x15, 0x00	  ;Look-Up Table Address Register
;     .db 0x16, 0x00	  ;Not Used
;     .db 0x17, 0x00	  ;Look-Up Table Data Register
     .db 0x18, 0x01	  ;GPIO Configuration Control Register
     .db 0x19, 0x00	  ;GPIO Status/Control Register
     .db 0x1A, 0x00	  ;Scratch Pad Register
     .db 0x1B, 0x00	  ;SwivelView Mode Register
     .db 0x1C, 0x00	  ;Line Byte Count Register
     .db 0xFF, 0xFF	  ;Last word, no more


g_LUT2Bpp:
     .db 0X00, 0X00, 0X00, 0
     .db 0X88, 0X88, 0X88, 0
     .db 0XCC, 0XCC, 0XCC, 0
     .db 0XFF, 0XFF, 0XFF, 0


g_LUT4Bpp:
     .db 0X00, 0X00, 0X00, 0
     .db 0X26, 0X26, 0X26, 0
     .db 0X4B, 0X4B, 0X4B, 0
     .db 0X71, 0X71, 0X71, 0
     .db 0X0E, 0X0E, 0X0E, 0
     .db 0X34, 0X34, 0X34, 0
     .db 0X59, 0X59, 0X59, 0
     .db 0XC0, 0XC0, 0XC0, 0
     .db 0X80, 0X80, 0X80, 0
     .db 0X4C, 0X4C, 0X4C, 0
     .db 0X97, 0X97, 0X97, 0
     .db 0XE3, 0XE3, 0XE3, 0
     .db 0X1C, 0X1C, 0X1C, 0
     .db 0X69, 0X69, 0X69, 0
     .db 0XB3, 0XB3, 0XB3, 0
     .db 0XFF, 0XFF, 0XFF, 0




ClearVideo:
		mov	R21,R16
		rjmp	CLV
ClearVMem:
		ldi	R21,0x55		;test byte
CLV:

		ldi	R20,VIDEOBASE		;SED RAM Base Address
		sts	ADR_EXLH,R20		;Lower memory Banks
		inc	R20
		sts	ADR_EXHL,R20		;Continous 48kb VideoMemory
		inc	R20
		sts	ADR_EXHH,R20
		

		ldi	ZL,0
		ldi	ZH,64			;Z point to Paged Video Memory
		ldi	XL,low(S1D_DISPLAY_SCANLINE_BYTES*S1D_DISPLAY_HEIGHT)
		ldi	XH,high(S1D_DISPLAY_SCANLINE_BYTES*S1D_DISPLAY_HEIGHT)
						;Count of test byte

Vsrt1:		st	Z+,R21
		sbiw	XL,1
		nop
		nop
		nop
		nop
		nop
		brne	Vsrt1			;fill bank
		ret


;****************
;* R3:R2 cimre, R4-t ir

VPoke:
		ldi	R20,VIDEOBASE		;SED RAM Base Address
		sts	ADR_EXLH,R20		;Continous 48kb VideoMemory
		inc	R20
		sts	ADR_EXHL,R20
		inc	R20
		sts	ADR_EXHH,R20

		ldi	ZL,0
		ldi	ZH,64			;Z point to upper memory
		add	ZL,R2
		adc	ZH,R3
		brcs	VPokeOverFlw

		st	Z,R4
VPokeOverFlw:
		ret



;******************************************************************************
; In: R16 - hany sort kell emelni az egesz kepernyon
;
ScrollUp:
		rcall	WaitToDMA
		ldi	R20,SRAMBASE		;SRAM Base Address
		sts	ADR_EXLH,R20		;Continous 48kb VideoMemory
		inc	R20
		sts	ADR_EXHL,R20
		inc	R20
		sts	ADR_EXHH,R20


		ldi	ZL,Low(16384)
		ldi	ZH,High(16384)


		ldi	YL,low(16384+S1D_DISPLAY_SCANLINE_BYTES*4)
		ldi	YH,High(16384+S1D_DISPLAY_SCANLINE_BYTES*4)

		ldi	XL,low(S1D_DISPLAY_SCANLINE_BYTES*(S1D_DISPLAY_HEIGHT-1))
		ldi	XH,high(S1D_DISPLAY_SCANLINE_BYTES*(S1D_DISPLAY_HEIGHT-1))
		
Scroll1:	ld	R7,Y+
		st	Z+,R7
		sbiw	XL,1
		brne	Scroll1
		ret


SwitchAllVideo:
		ldi	R20,SRAMBASE		;SED RAM Base Address
		sts	ADR_EXLH,R20		;Lower memory Banks
		inc	R20
		sts	ADR_EXHL,R20		;Continous 48kb VideoMemory
		inc	R20
		sts	ADR_EXHH,R20
		ret



;**************************************
; R16 - ascii char
; Y - address of video RAM
;
PutChr:         mov	R0,R16
		rcall	WaitToDMA
		mov	R16,R0
                ldi	R17,64
		add	YH,R17
		rcall	SwitchAllVideo
		ldi	R22,12			;12 pixel magas
		mul	R16,R22
		ldi	ZL,low(CH8x12*2)
		ldi	ZH,High(CH8x12*2)
		ldi	R16,CH8x12/32768
		out	RAMPZ,R16
		add	ZL,R0
		adc	ZH,R1		;Z - address of char bitmap

		ldi	R20,Low(S1D_DISPLAY_SCANLINE_BYTES)
		ldi	R21,High(S1D_DISPLAY_SCANLINE_BYTES)
PutChr1:
		push	YL
		push	YH
		ldi	R23,8			;8 pixel szeles
		elpm	R16,Z+
PutChar2:
		ldi	R17,0x00
		rol	R16
		brcc	PixelBackCol
		ori	R17,0xF0
PixelBackCol:
		rol	R16
		brcc	PixelBackCol1
		ori	R17,0x0F
PixelBackCol1:
		st	Y+,R17
		dec	R23
		brne	PutChar2

		pop	YH
		pop	YL
		add	YL,R20
		adc	YH,R21
		dec	R22
		brne	PutChr1
		ret

;***********************************
; RAMPZ:Z - point to string in FLASH
; Y - Video offset
;
PutStrFLASH: 	elpm	R16,Z+
		cpi	R16,0
		brne	PutStr1
		ret
PutStr1:
		push	ZL
		push	ZH
		push	YL
		push	YH
		rcall	PutChr
		pop	YH
		pop	YL
		pop	ZH
		pop	ZL
		adiw	YL,4		;16 szinben 8 pixel = 4 byte
		rjmp	PutStrFLASH

;***********************************
; Z - point to string in SRAM
; Y - Video offset
;
PutStrSRAM: 	ld	R16,Z+
		cpi	R16,0
		brne	PutStr2
		ret
PutStr2:
		push	ZL
		push	ZH
		push	YL
		push	YH
		rcall	PutChr
		pop	YH
		pop	YL
		pop	ZH
		pop	ZL
		adiw	YL,4		;16 szinben 8 pixel = 4 byte
		rjmp	PutStrSRAM



WaitToDMA:
		push	R16
		nop
		nop
		nop
		nop
		nop
		nop
		lds	R16,ADR_DMAC
		andi	R16,0x01		;DMA active?
		pop	R16
		brne	WaitToDMA
		ret
		

StartDMA:
		ldi	R16,0x01
		sts	ADR_DMAC,R16
		ret



;***********************************
; 
; 
;


LCD_LightMayOff:
		lds	R16,LCDFlag
		andi	R16,1
		brne	LCD_LTOnOff
		ret
LCD_LTOnOff:
		lds	R16,SCNT4+0
		lds	R17,SCNT4+1
		or	R16,R17
		breq	LCD_LTOff
		ret

LCD_LTOff:
		clr	R16
		rcall	LCD_LightONOFF		;LCD Off
		ret



LCD_LightMayOn:
		lds	R16,LCDFlag
		andi	R16,1
		brne	LCD_LTOn
		rjmp	LCD_LTOn1
LCD_LTOn:
		ldi	R16,1
		rcall	LCD_LightONOFF
		lds	R16,LCDFlag
		ori	R16,1
		sts	LCDFlag,R16
LCD_LTOn1:
		cli
		ldi	R16,low(LCDBackLightTime)
		sts	SCNT4+0,R16
		ldi	R16,high(LCDBackLightTime)
		sts	SCNT4+1,R16		;LCD Back Light Timer
		sei
		ret




;***********************************
; LCD_LightONOFF
; 
; In: R16 - 0 = LCD Light Off 
;	    1 = LCD Light On
;
;
;
LCD_LightONOFF:
		rcall	WaitToDMA
		ldi	R17,VIDEOBASE+7
		sts	ADR_EXHH,R17
		dec	R16			;invert bit 0
		andi	R16,1			;keep bit 0		
		sts	0xFFE0+GPIOStatus,R16	;SED GPIO Control Register
		ret